diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/admin-bar.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/admin-bar.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/admin-bar.php	2012-11-28 16:28:20.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/admin-bar.php	2013-07-08 15:05:42.000000000 -0500
***************
*** 8,15 ****
  /**
   * Instantiate the admin bar object and set it up as a global for access elsewhere.
   *
!  * To hide the admin bar, you're looking in the wrong place. Unhooking this function will not
!  * properly remove the admin bar. For that, use show_admin_bar(false) or the show_admin_bar filter.
   *
   * @since 3.1.0
   * @access private
--- 8,15 ----
  /**
   * Instantiate the admin bar object and set it up as a global for access elsewhere.
   *
!  * UNHOOKING THIS FUNCTION WILL NOT PROPERLY REMOVE THE ADMIN BAR.
!  * For that, use show_admin_bar(false) or the 'show_admin_bar' filter.
   *
   * @since 3.1.0
   * @access private
***************
*** 36,42 ****
  
  	return true;
  }
! add_action( 'init', '_wp_admin_bar_init' ); // Don't remove. Wrong way to disable.
  
  /**
   * Render the admin bar to the page based on the $wp_admin_bar->menu member var.
--- 36,44 ----
  
  	return true;
  }
! // Don't remove. Wrong way to disable.
! add_action( 'template_redirect', '_wp_admin_bar_init', 0 );
! add_action( 'admin_init', '_wp_admin_bar_init' );
  
  /**
   * Render the admin bar to the page based on the $wp_admin_bar->menu member var.
***************
*** 174,181 ****
  	$user_info  = get_avatar( $user_id, 64 );
  	$user_info .= "<span class='display-name'>{$current_user->display_name}</span>";
  
! 	if ( $current_user->display_name !== $current_user->user_nicename )
! 		$user_info .= "<span class='username'>{$current_user->user_nicename}</span>";
  
  	$wp_admin_bar->add_menu( array(
  		'parent' => 'user-actions',
--- 176,183 ----
  	$user_info  = get_avatar( $user_id, 64 );
  	$user_info .= "<span class='display-name'>{$current_user->display_name}</span>";
  
! 	if ( $current_user->display_name !== $current_user->user_login )
! 		$user_info .= "<span class='username'>{$current_user->user_login}</span>";
  
  	$wp_admin_bar->add_menu( array(
  		'parent' => 'user-actions',
***************
*** 227,235 ****
  		$blogname = sprintf( __('Global Dashboard: %s'), esc_html( $current_site->site_name ) );
  	}
  
! 	$title = wp_html_excerpt( $blogname, 40 );
! 	if ( $title != $blogname )
! 		$title = trim( $title ) . '&hellip;';
  
  	$wp_admin_bar->add_menu( array(
  		'id'    => 'site-name',
--- 229,235 ----
  		$blogname = sprintf( __('Global Dashboard: %s'), esc_html( $current_site->site_name ) );
  	}
  
! 	$title = wp_html_excerpt( $blogname, 40, '&hellip;' );
  
  	$wp_admin_bar->add_menu( array(
  		'id'    => 'site-name',
***************
*** 429,435 ****
  		if ( 'post' == $current_screen->base
  			&& 'add' != $current_screen->action
  			&& ( $post_type_object = get_post_type_object( $post->post_type ) )
! 			&& current_user_can( $post_type_object->cap->read_post, $post->ID )
  			&& ( $post_type_object->public )
  			&& ( $post_type_object->show_in_admin_bar ) )
  		{
--- 429,435 ----
  		if ( 'post' == $current_screen->base
  			&& 'add' != $current_screen->action
  			&& ( $post_type_object = get_post_type_object( $post->post_type ) )
! 			&& current_user_can( 'read_post', $post->ID )
  			&& ( $post_type_object->public )
  			&& ( $post_type_object->show_in_admin_bar ) )
  		{
***************
*** 457,463 ****
  
  		if ( ! empty( $current_object->post_type )
  			&& ( $post_type_object = get_post_type_object( $current_object->post_type ) )
! 			&& current_user_can( $post_type_object->cap->edit_post, $current_object->ID )
  			&& $post_type_object->show_ui && $post_type_object->show_in_admin_bar )
  		{
  			$wp_admin_bar->add_menu( array(
--- 457,463 ----
  
  		if ( ! empty( $current_object->post_type )
  			&& ( $post_type_object = get_post_type_object( $current_object->post_type ) )
! 			&& current_user_can( 'edit_post', $current_object->ID )
  			&& $post_type_object->show_ui && $post_type_object->show_in_admin_bar )
  		{
  			$wp_admin_bar->add_menu( array(
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/atomlib.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/atomlib.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/atomlib.php	2012-01-08 11:01:11.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/atomlib.php	2013-05-07 11:37:21.000000000 -0500
***************
*** 131,138 ****
  
              if(!xml_parse($parser, $data, feof($fp))) {
                  trigger_error(sprintf(__('XML error: %s at line %d')."\n",
!                     xml_error_string(xml_get_error_code($xml_parser)),
!                     xml_get_current_line_number($xml_parser)));
                  $ret = false;
                  break;
              }
--- 131,138 ----
  
              if(!xml_parse($parser, $data, feof($fp))) {
                  trigger_error(sprintf(__('XML error: %s at line %d')."\n",
!                     xml_error_string(xml_get_error_code($parser)),
!                     xml_get_current_line_number($parser)));
                  $ret = false;
                  break;
              }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/author-template.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/author-template.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/author-template.php	2012-09-04 11:29:28.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/author-template.php	2013-07-09 23:20:41.000000000 -0500
***************
*** 134,140 ****
   */
  function get_the_author_link() {
  	if ( get_the_author_meta('url') ) {
! 		return '<a href="' . get_the_author_meta('url') . '" title="' . esc_attr( sprintf(__("Visit %s&#8217;s website"), get_the_author()) ) . '" rel="author external">' . get_the_author() . '</a>';
  	} else {
  		return get_the_author();
  	}
--- 134,140 ----
   */
  function get_the_author_link() {
  	if ( get_the_author_meta('url') ) {
! 		return '<a href="' . esc_url( get_the_author_meta('url') ) . '" title="' . esc_attr( sprintf(__("Visit %s&#8217;s website"), get_the_author()) ) . '" rel="author external">' . get_the_author() . '</a>';
  	} else {
  		return get_the_author();
  	}
***************
*** 200,206 ****
  		return false;
  	$link = sprintf(
  		'<a href="%1$s" title="%2$s" rel="author">%3$s</a>',
! 		get_author_posts_url( $authordata->ID, $authordata->user_nicename ),
  		esc_attr( sprintf( __( 'Posts by %s' ), get_the_author() ) ),
  		get_the_author()
  	);
--- 200,206 ----
  		return false;
  	$link = sprintf(
  		'<a href="%1$s" title="%2$s" rel="author">%3$s</a>',
! 		esc_url( get_author_posts_url( $authordata->ID, $authordata->user_nicename ) ),
  		esc_attr( sprintf( __( 'Posts by %s' ), get_the_author() ) ),
  		get_the_author()
  	);
***************
*** 244,250 ****
   * <li>optioncount (boolean) (false): Show the count in parenthesis next to the
   * author's name.</li>
   * <li>exclude_admin (boolean) (true): Exclude the 'admin' user that is
!  * installed bydefault.</li>
   * <li>show_fullname (boolean) (false): Show their full names.</li>
   * <li>hide_empty (boolean) (true): Don't show authors without any posts.</li>
   * <li>feed (string) (''): If isn't empty, show links to author's feeds.</li>
--- 244,250 ----
   * <li>optioncount (boolean) (false): Show the count in parenthesis next to the
   * author's name.</li>
   * <li>exclude_admin (boolean) (true): Exclude the 'admin' user that is
!  * installed by default.</li>
   * <li>show_fullname (boolean) (false): Show their full names.</li>
   * <li>hide_empty (boolean) (true): Don't show authors without any posts.</li>
   * <li>feed (string) (''): If isn't empty, show links to author's feeds.</li>
***************
*** 372,381 ****
  function is_multi_author() {
  	global $wpdb;
  
! 	if ( false === ( $is_multi_author = wp_cache_get('is_multi_author', 'posts') ) ) {
  		$rows = (array) $wpdb->get_col("SELECT DISTINCT post_author FROM $wpdb->posts WHERE post_type = 'post' AND post_status = 'publish' LIMIT 2");
  		$is_multi_author = 1 < count( $rows ) ? 1 : 0;
! 		wp_cache_set('is_multi_author', $is_multi_author, 'posts');
  	}
  
  	return apply_filters( 'is_multi_author', (bool) $is_multi_author );
--- 372,381 ----
  function is_multi_author() {
  	global $wpdb;
  
! 	if ( false === ( $is_multi_author = get_transient( 'is_multi_author' ) ) ) {
  		$rows = (array) $wpdb->get_col("SELECT DISTINCT post_author FROM $wpdb->posts WHERE post_type = 'post' AND post_status = 'publish' LIMIT 2");
  		$is_multi_author = 1 < count( $rows ) ? 1 : 0;
! 		set_transient( 'is_multi_author', $is_multi_author );
  	}
  
  	return apply_filters( 'is_multi_author', (bool) $is_multi_author );
***************
*** 387,392 ****
   * @private
   */
  function __clear_multi_author_cache() {
! 	wp_cache_delete('is_multi_author', 'posts');
  }
  add_action('transition_post_status', '__clear_multi_author_cache');
--- 387,392 ----
   * @private
   */
  function __clear_multi_author_cache() {
! 	delete_transient( 'is_multi_author' );
  }
  add_action('transition_post_status', '__clear_multi_author_cache');
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/bookmark.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/bookmark.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/bookmark.php	2012-09-13 11:41:43.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/bookmark.php	2013-07-29 13:18:58.000000000 -0500
***************
*** 186,192 ****
  	}
  
  	if ( ! empty($search) ) {
! 		$search = like_escape($search);
  		$search = " AND ( (link_url LIKE '%$search%') OR (link_name LIKE '%$search%') OR (link_description LIKE '%$search%') ) ";
  	}
  
--- 186,192 ----
  	}
  
  	if ( ! empty($search) ) {
! 		$search = esc_sql( like_escape( $search ) );
  		$search = " AND ( (link_url LIKE '%$search%') OR (link_name LIKE '%$search%') OR (link_description LIKE '%$search%') ) ";
  	}
  
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/cache.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/cache.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/cache.php	2012-11-17 09:11:29.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/cache.php	2013-01-22 14:44:30.000000000 -0600
***************
*** 19,25 ****
   * @param mixed $data The data to add to the cache store
   * @param string $group The group to add the cache to
   * @param int $expire When the cache data should be expired
!  * @return unknown
   */
  function wp_cache_add($key, $data, $group = '', $expire = 0) {
  	global $wp_object_cache;
--- 19,25 ----
   * @param mixed $data The data to add to the cache store
   * @param string $group The group to add the cache to
   * @param int $expire When the cache data should be expired
!  * @return bool False if cache key and group already exist, true on success
   */
  function wp_cache_add($key, $data, $group = '', $expire = 0) {
  	global $wp_object_cache;
***************
*** 85,91 ****
   * @uses $wp_object_cache Object Cache Class
   * @see WP_Object_Cache::flush()
   *
!  * @return bool Always returns true
   */
  function wp_cache_flush() {
  	global $wp_object_cache;
--- 85,91 ----
   * @uses $wp_object_cache Object Cache Class
   * @see WP_Object_Cache::flush()
   *
!  * @return bool False on failure, true on success
   */
  function wp_cache_flush() {
  	global $wp_object_cache;
***************
*** 152,158 ****
   * @param mixed $data The contents to store in the cache
   * @param string $group Where to group the cache contents
   * @param int $expire When to expire the cache contents
!  * @return bool False if cache key and group already exist, true on success
   */
  function wp_cache_replace($key, $data, $group = '', $expire = 0) {
  	global $wp_object_cache;
--- 152,158 ----
   * @param mixed $data The contents to store in the cache
   * @param string $group Where to group the cache contents
   * @param int $expire When to expire the cache contents
!  * @return bool False if not exists, true if contents were replaced
   */
  function wp_cache_replace($key, $data, $group = '', $expire = 0) {
  	global $wp_object_cache;
***************
*** 171,177 ****
   * @param mixed $data The contents to store in the cache
   * @param string $group Where to group the cache contents
   * @param int $expire When to expire the cache contents
!  * @return bool False if cache key and group already exist, true on success
   */
  function wp_cache_set($key, $data, $group = '', $expire = 0) {
  	global $wp_object_cache;
--- 171,177 ----
   * @param mixed $data The contents to store in the cache
   * @param string $group Where to group the cache contents
   * @param int $expire When to expire the cache contents
!  * @return bool False on failure, true on success
   */
  function wp_cache_set($key, $data, $group = '', $expire = 0) {
  	global $wp_object_cache;
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/canonical.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/canonical.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/canonical.php	2012-09-11 07:27:25.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/canonical.php	2013-07-08 15:27:06.000000000 -0500
***************
*** 18,24 ****
   * one or the other.
   *
   * Prevents redirection for feeds, trackbacks, searches, comment popup, and
!  * admin URLs. Does not redirect on non-pretty-permalink-supporting IIS 7,
   * page/post previews, WP admin, Trackbacks, robots.txt, searches, or on POST
   * requests.
   *
--- 18,24 ----
   * one or the other.
   *
   * Prevents redirection for feeds, trackbacks, searches, comment popup, and
!  * admin URLs. Does not redirect on non-pretty-permalink-supporting IIS 7+,
   * page/post previews, WP admin, Trackbacks, robots.txt, searches, or on POST
   * requests.
   *
***************
*** 272,280 ****
  				$redirect['query'] = remove_query_arg( 'cpage', $redirect['query'] );
  			}
  
! 			$redirect['path'] = user_trailingslashit( preg_replace('|/index.php/?$|', '/', $redirect['path']) ); // strip off trailing /index.php/
! 			if ( !empty( $addl_path ) && $wp_rewrite->using_index_permalinks() && strpos($redirect['path'], '/index.php/') === false )
! 				$redirect['path'] = trailingslashit($redirect['path']) . 'index.php/';
  			if ( !empty( $addl_path ) )
  				$redirect['path'] = trailingslashit($redirect['path']) . $addl_path;
  			$redirect_url = $redirect['scheme'] . '://' . $redirect['host'] . $redirect['path'];
--- 272,280 ----
  				$redirect['query'] = remove_query_arg( 'cpage', $redirect['query'] );
  			}
  
! 			$redirect['path'] = user_trailingslashit( preg_replace('|/' . preg_quote( $wp_rewrite->index, '|' ) . '/?$|', '/', $redirect['path']) ); // strip off trailing /index.php/
! 			if ( !empty( $addl_path ) && $wp_rewrite->using_index_permalinks() && strpos($redirect['path'], '/' . $wp_rewrite->index . '/') === false )
! 				$redirect['path'] = trailingslashit($redirect['path']) . $wp_rewrite->index . '/';
  			if ( !empty( $addl_path ) )
  				$redirect['path'] = trailingslashit($redirect['path']) . $addl_path;
  			$redirect_url = $redirect['scheme'] . '://' . $redirect['host'] . $redirect['path'];
***************
*** 324,330 ****
  		unset($redirect['port']);
  
  	// trailing /index.php
! 	$redirect['path'] = preg_replace('|/index.php/*?$|', '/', $redirect['path']);
  
  	// Remove trailing spaces from the path
  	$redirect['path'] = preg_replace( '#(%20| )+$#', '', $redirect['path'] );
--- 324,330 ----
  		unset($redirect['port']);
  
  	// trailing /index.php
! 	$redirect['path'] = preg_replace('|/' . preg_quote( $wp_rewrite->index, '|' ) . '/*?$|', '/', $redirect['path']);
  
  	// Remove trailing spaces from the path
  	$redirect['path'] = preg_replace( '#(%20| )+$#', '', $redirect['path'] );
***************
*** 337,343 ****
  		$redirect['query'] = trim(preg_replace( '#(^|&)(p|page_id|cat|tag)=?(&|$)#', '&', $redirect['query']), '&');
  
  		// Redirect obsolete feeds
! 		$redirect['query'] = preg_replace( '#(^|&)feed=rss(&|$)#', '$1feed=rss2$3', $redirect['query'] );
  
  		// Remove redundant leading ampersands
  		$redirect['query'] = preg_replace( '#^\??&*?#', '', $redirect['query'] );
--- 337,343 ----
  		$redirect['query'] = trim(preg_replace( '#(^|&)(p|page_id|cat|tag)=?(&|$)#', '&', $redirect['query']), '&');
  
  		// Redirect obsolete feeds
! 		$redirect['query'] = preg_replace( '#(^|&)feed=rss(&|$)#', '$1feed=rss2$2', $redirect['query'] );
  
  		// Remove redundant leading ampersands
  		$redirect['query'] = preg_replace( '#^\??&*?#', '', $redirect['query'] );
***************
*** 345,351 ****
  
  	// strip /index.php/ when we're not using PATHINFO permalinks
  	if ( !$wp_rewrite->using_index_permalinks() )
! 		$redirect['path'] = str_replace('/index.php/', '/', $redirect['path']);
  
  	// trailing slashes
  	if ( is_object($wp_rewrite) && $wp_rewrite->using_permalinks() && !is_404() && (!is_front_page() || ( is_front_page() && (get_query_var('paged') > 1) ) ) ) {
--- 345,351 ----
  
  	// strip /index.php/ when we're not using PATHINFO permalinks
  	if ( !$wp_rewrite->using_index_permalinks() )
! 		$redirect['path'] = str_replace( '/' . $wp_rewrite->index . '/', '/', $redirect['path'] );
  
  	// trailing slashes
  	if ( is_object($wp_rewrite) && $wp_rewrite->using_permalinks() && !is_404() && (!is_front_page() || ( is_front_page() && (get_query_var('paged') > 1) ) ) ) {
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/capabilities.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/capabilities.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/capabilities.php	2012-12-07 03:53:27.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/capabilities.php	2013-07-08 15:05:42.000000000 -0500
***************
*** 158,164 ****
  	 * @param string $role Role name.
  	 * @param string $display_name Role display name.
  	 * @param array $capabilities List of role capabilities in the above format.
! 	 * @return null|WP_Role WP_Role object if role is added, null if already exists.
  	 */
  	function add_role( $role, $display_name, $capabilities = array() ) {
  		if ( isset( $this->roles[$role] ) )
--- 158,164 ----
  	 * @param string $role Role name.
  	 * @param string $display_name Role display name.
  	 * @param array $capabilities List of role capabilities in the above format.
! 	 * @return WP_Role|null WP_Role object if role is added, null if already exists.
  	 */
  	function add_role( $role, $display_name, $capabilities = array() ) {
  		if ( isset( $this->roles[$role] ) )
***************
*** 239,245 ****
  	 * @access public
  	 *
  	 * @param string $role Role name.
! 	 * @return object|null Null, if role does not exist. WP_Role object, if found.
  	 */
  	function get_role( $role ) {
  		if ( isset( $this->role_objects[$role] ) )
--- 239,245 ----
  	 * @access public
  	 *
  	 * @param string $role Role name.
! 	 * @return WP_Role|null WP_Role object if found, null if the role does not exist.
  	 */
  	function get_role( $role ) {
  		if ( isset( $this->role_objects[$role] ) )
***************
*** 535,541 ****
  			// to int 1.
  			if ( ! is_numeric( $value ) )
  				return false;
! 			$value = absint( $value );
  		} else {
  			$value = trim( $value );
  		}
--- 535,543 ----
  			// to int 1.
  			if ( ! is_numeric( $value ) )
  				return false;
! 			$value = intval( $value );
! 			if ( $value < 1 )
! 				return false;
  		} else {
  			$value = trim( $value );
  		}
***************
*** 803,808 ****
--- 805,811 ----
  		foreach ( (array) $this->roles as $oldrole )
  			unset( $this->caps[$oldrole] );
  
+ 		$old_roles = $this->roles;
  		if ( !empty( $role ) ) {
  			$this->caps[$role] = true;
  			$this->roles = array( $role => true );
***************
*** 812,818 ****
  		update_user_meta( $this->ID, $this->cap_key, $this->caps );
  		$this->get_role_caps();
  		$this->update_user_level_from_caps();
! 		do_action( 'set_user_role', $this->ID, $role );
  	}
  
  	/**
--- 815,821 ----
  		update_user_meta( $this->ID, $this->cap_key, $this->caps );
  		$this->get_role_caps();
  		$this->update_user_level_from_caps();
! 		do_action( 'set_user_role', $this->ID, $role, $old_roles );
  	}
  
  	/**
***************
*** 1159,1166 ****
  	case 'delete_post_meta':
  	case 'add_post_meta':
  		$post = get_post( $args[0] );
! 		$post_type_object = get_post_type_object( $post->post_type );
! 		$caps = map_meta_cap( $post_type_object->cap->edit_post, $user_id, $post->ID );
  
  		$meta_key = isset( $args[ 1 ] ) ? $args[ 1 ] : false;
  
--- 1162,1168 ----
  	case 'delete_post_meta':
  	case 'add_post_meta':
  		$post = get_post( $args[0] );
! 		$caps = map_meta_cap( 'edit_post', $user_id, $post->ID );
  
  		$meta_key = isset( $args[ 1 ] ) ? $args[ 1 ] : false;
  
***************
*** 1175,1183 ****
  	case 'edit_comment':
  		$comment = get_comment( $args[0] );
  		$post = get_post( $comment->comment_post_ID );
! 		$post_type_object = get_post_type_object( $post->post_type );
! 
! 		$caps = map_meta_cap( $post_type_object->cap->edit_post, $user_id, $post->ID );
  		break;
  	case 'unfiltered_upload':
  		if ( defined('ALLOW_UNFILTERED_UPLOADS') && ALLOW_UNFILTERED_UPLOADS && ( !is_multisite() || is_super_admin( $user_id ) )  )
--- 1177,1183 ----
  	case 'edit_comment':
  		$comment = get_comment( $args[0] );
  		$post = get_post( $comment->comment_post_ID );
! 		$caps = map_meta_cap( 'edit_post', $user_id, $post->ID );
  		break;
  	case 'unfiltered_upload':
  		if ( defined('ALLOW_UNFILTERED_UPLOADS') && ALLOW_UNFILTERED_UPLOADS && ( !is_multisite() || is_super_admin( $user_id ) )  )
***************
*** 1371,1377 ****
   * @since 2.0.0
   *
   * @param string $role Role name.
!  * @return object
   */
  function get_role( $role ) {
  	global $wp_roles;
--- 1371,1377 ----
   * @since 2.0.0
   *
   * @param string $role Role name.
!  * @return WP_Role|null WP_Role object if found, null if the role does not exist.
   */
  function get_role( $role ) {
  	global $wp_roles;
***************
*** 1391,1397 ****
   * @param string $role Role name.
   * @param string $display_name Display name for role.
   * @param array $capabilities List of capabilities, e.g. array( 'edit_posts' => true, 'delete_posts' => false );
!  * @return null|WP_Role WP_Role object if role is added, null if already exists.
   */
  function add_role( $role, $display_name, $capabilities = array() ) {
  	global $wp_roles;
--- 1391,1397 ----
   * @param string $role Role name.
   * @param string $display_name Display name for role.
   * @param array $capabilities List of capabilities, e.g. array( 'edit_posts' => true, 'delete_posts' => false );
!  * @return WP_Role|null WP_Role object if role is added, null if already exists.
   */
  function add_role( $role, $display_name, $capabilities = array() ) {
  	global $wp_roles;
